--- old/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	2016-07-18 18:32:09.815091688 +0100
+++ new/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	2016-07-18 18:32:09.828370782 +0100
@@ -27,6 +27,7 @@
 /*
  * Copyright (c) 2015, Joyent, Inc. All rights reserved.
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2016 RackTop Systems.
  */
 
 #include <sys/types.h>
@@ -1104,7 +1105,8 @@
 
 	if (tp->tn_type != VDIR ||
 	    (error = secpolicy_fs_linkdir(cred, dvp->v_vfsp)) == 0)
-		error = tdirdelete(parent, tp, nm, DR_REMOVE, cred);
+		error = tdirdelete(parent, tp, nm, tp->tn_type == VDIR ?
+		    DR_RMDIR : DR_REMOVE, cred);
 
 	rw_exit(&tp->tn_rwlock);
 	rw_exit(&parent->tn_rwlock);
